#pragma once

#include "includes.h"

class OblastObrazku : public Gtk::DrawingArea
{
private:
	Gdk::Pixbuf* _pixbuf = nullptr;

public:
	void set_pixbuf(Gdk::Pixbuf* pixbuf) noexcept
	{
		_pixbuf = pixbuf;
		queue_draw();
	}

protected:
	bool on_draw(const Cairo::RefPtr<Cairo::Context>& cr) override
	{
		if (!_pixbuf)
			return false;
		Gtk::Allocation allocation = get_allocation();
		const int width = allocation.get_width();
		const int height = allocation.get_height();
		Glib::RefPtr<Gdk::Pixbuf> pb =
			Gdk::Pixbuf::create(Gdk::COLORSPACE_RGB, true, 8, width, height);
		double pomer;
		double pocX = 0;
		double pocY = 0;
		double sirka_cil = (double)width;
		double vyska_cil = (double)height;
		if (_pixbuf)
		{
			if (((double)_pixbuf->get_width() / width) > ((double)_pixbuf->get_height() / height))
			{
				pomer = (double)width / _pixbuf->get_width();
				vyska_cil = ((double)_pixbuf->get_height()*pomer);
				pocY = ((double)height - vyska_cil)/2;
			}
			else
			{
				pomer = (double)height / _pixbuf->get_height();
				sirka_cil = ((double)_pixbuf->get_width()*pomer);
				pocX = ((double)width - sirka_cil)/2;

			}
			_pixbuf->scale(pb,  0, 0, width, height,  0, 0,
				(double)pomer,
				(double)pomer, Gdk::InterpType::INTERP_NEAREST);
		}
		Gdk::Cairo::set_source_pixbuf(cr, pb, pocX, pocY);
		cr->rectangle(0, 0, width - pocX, height - pocY);
		cr->fill();
		pb.reset();
		return true;
	}
};